!************************************************************************************
!
! Appends values as a third element of the first axis ( x , y, appended_value ).
!
!************************************************************************************

program APPEND_VALUES

  use sep
  implicit none

  integer				:: nelem, nnodes, ntri, ntraces, itri
  real					:: trace1, trace2, trace3, val1, val2, val3
  real, allocatable, dimension (:,:)    :: coord_in, output
  real, allocatable, dimension (:)      :: nodes, val

  call sep_init()
  
  ! Get input data as a table
  call from_history('n1', nelem, 1)
  call from_history('n2', nnodes,1)
  call from_history('n3', ntri,  1)

  call from_aux('val','n3',ntraces,1)

  call to_history('n1',3 )
  call to_history('n2',3 )
  call to_history('n3',ntri)
  call to_history('d1',1.)
  call to_history('d2',1.)
  call to_history('d3',1.)
  call to_history('o1',1.)
  call to_history('o2',1.)
  call to_history('o3',1.)
  call to_history('label1',"(x,y,val)")
  call to_history('label2',"3 Nodes"  )
  call to_history('label3',"Triangles")

  allocate ( coord_in(2,3) , output(3,3), val(ntraces), nodes(3) )
  call sep_read(val,"val")           	! (3 x 1)


  ! For each triangle grab the node coordinates
  do itri=1, ntri
	call sep_read(coord_in)      	! (2 x 3) Coordinates for triangle nodes
	call sep_read(nodes,"nodes") 	! (3 x 1) Trace number for each node

	trace1 = nodes(1)
	trace2 = nodes(2)
	trace3 = nodes(3)

	val1=val(trace1)
	val2=val(trace2)
	val3=val(trace3)

	output(1:2,:) = coord_in(:,:)
	output(3,1)   = val1
	output(3,2)   = val2
	output(3,3)   = val3
	call sep_write(output)
  end do

  !deallocate ( coord_in, nodes, val, output )
  call sep_close
  !call exit(0);

end program




