program AVG_TIME_DELAY

use sep
implicit none

  integer					:: npar, nnodes, ntri, nsrc, nadded, it, is
  double precision				:: avg
  real, dimension(:,:,:), allocatable 		:: output
  real, dimension(:,:,:,:), allocatable 	:: input

 call sep_init()

 call from_history("n1", npar,   6)
 call from_history("n2", nnodes, 3)
 call from_history("n3", ntri,   1)
 call from_history("n4", nsrc,   1)

 allocate( input(npar,nnodes,ntri,nsrc), output(4,nnodes,ntri) )
 input  = 0.0
 output = 0.0
 call sep_read(input)


 do it=1, ntri
	avg = 0.0
	nadded = 0
 	do is=1, nsrc
		if ( input(6,1,it,is) > 0 ) cycle
		avg = avg + dble(input(3,1,it,is))
		nadded = nadded + 1
	end do

	output(1:2,:,it) = input(1:2,:,it,1) ! Assign (x , y)

	if (nadded > 0) then
		avg = (avg / dble(nadded))
		output(3,:,it)   = real(avg)
		output(4,:,it)   = 0.0
	else
		output(3,:,it)   = -1
		output(4,:,it)   = 1.0
	end if
 end do

 call sep_write(output)

 call to_history("n1",     4 )
 call to_history("n2",nnodes )
 call to_history("n3",ntri   )
 call to_history("n4",     1 )

 call to_history("label1", "(x, y, avg time delay [s], kill_val)" )
 call to_history("label2", "Node" )
 call to_history("label3", "Triangle" )
 call to_history("label4", " " )

 call sep_close()

end program
