program CalcPhase
  use sep
  implicit none

  integer             :: n1,n2,n3,esize,kk
  complex,allocatable :: data(:,:,:)
  real,allocatable    :: phase(:,:,:)
  real,parameter      :: pi = 3.14159265359

  call sep_init()
  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("esize",esize)
  if (esize.ne.8) call erexit("Error:  esize.ne.8")
  call to_history("esize",4)
  call sep_close()

  allocate(data(n1,n2,n3),phase(n1,n2,n3))

  ! Convert to Phase
  do kk=1,n3
    call sreed("in" ,data(:,:,kk),8*n1*n2)
  end do
  phase = atan2(aimag(data),real(data))
  where (phase.lt.0) phase = phase+2*pi
  do kk=1,n3
    call srite("out",phase(:,:,kk),4*n1*n2)
  end do

  ! Exit this
  deallocate(data,phase)
  call exit(0)

end program
