program CollectStationLocs

  use sep
  implicit none


  real,allocatable :: collected(:,:),datain(:,:)
  integer          :: maxnr,countr
  integer          :: ii,jj,kk
  integer          :: n1,n2
  integer          :: key1,key2
  logical          :: found

  call sep_init()

  call from_param('maxnr',maxnr,10000)
  call from_param('key1',key1,3)
  call from_param('key2',key2,4)

  call from_history('n1',n1,1)
  call from_history('n2',n2,1)

  allocate(datain(n1,n2),collected(n1,maxnr))

  call sreed('in',datain,4*size(datain))

  countr=1
  collected(:,countr)=datain(:,1)
  do ii=1,n2
    found=.false.
    do jj=1,countr
      if ((nint(collected(key1,jj)).eq.nint(datain(key1,ii))) .and. (nint(collected(key2,jj)).eq.nint(datain(key2,ii)))) then
        found=.true.
      end if
      if (found) cycle
    end do
    if (found) cycle
    countr=countr+1
    collected(:,countr)=datain(:,ii)
  end do

  call srite('out',collected(:,1:countr),4*n1*countr)
  call to_history('n1',    n1)
  call to_history('n2',countr)
  call sep_close()

end program
