! Fourier transform along time axis only for the raw data input. No pre "flipping" and "stacking"
! neccessary.

program FFT1d

  use sep
  use fourier

  implicit none
  complex, allocatable, dimension(:) 	:: ctrace
  real, allocatable, dimension(:) 	:: trace
  integer                              	:: nt, ntrace, itrace
  real                                 	:: ot, dt, o2, d2, sign1
  real                                 	:: ow, dw, wt

  call sep_init()

  call from_history("n1", nt)
  call from_history("o1", ot)
  call from_history("d1", dt)
  call from_history("n2", ntrace,1)
  call from_history("o2", o2,0.0)
  call from_history("d2", d2,1.0)

  write(0,*) 'n1 = ', nt, 'ntrace = ',ntrace

!-----------------------------------
 call from_param("sign1", sign1)
!-----------------------------------

  dw = 1./((nt-1)*dt)
  ow = -1./(2*dt)

  !dw = 1./(nt*dt)
  !ow = -nt/2*dw

  call to_history("n1", nt)
  call to_history("o1", ow)
  call to_history("d1", dw)
  call to_history("n2", ntrace)
  call to_history('label1', 'Frequency [Hz]')	! Needed since "Pad" doesnt keep labels for some reason
  call to_history("esize", 8)			! (since the data are complex values)

  allocate(trace(nt),ctrace(nt))
  trace = 0.

  call ft_init(nt, ntrace)

!------ Perform 1D FFT -------------
  do itrace=1,ntrace
	call sep_read(trace)
	ctrace = trace
	call ft1axis_1D(.false., sign1, ctrace)
	call sep_write(ctrace)
  end do
!-----------------------------------

  deallocate(trace)
  call exit(0)
end program FFT1d

