program MATCH_LP_2_XY

use sep
implicit none

integer					:: n1, nnodes, ntri, ntraces, it, in, trace !rec_point, rec_line,
integer					:: rec_x_key, rec_y_key, rec_line_key, rec_point_key
integer					:: found, live_tri, dead_tri, nkeys
real					:: sigma, x1, x2, y1, y2, aa, rec_point, rec_line
real, dimension(:,:), allocatable	:: xylp, polys, output

 call sep_init()
 call from_history("n1",n1,2)     	! (x,y) per node
 call from_history("n2",nnodes,3) 	! 3 nodes per triangle
 call from_history("n3",ntri,1)   	! number of triangles
 call from_aux("xylp","n2",ntraces,1)
 call from_aux("xylp","n1",nkeys,1)


 call from_param("sigma",sigma, 0.0) 	! 0.0 means a perfect match, which it theoretically should be
 call from_param("rec_x_key",rec_x_key)
 call from_param("rec_y_key",rec_y_key) 	
 call from_param("rec_line_key",rec_line_key) 	
 call from_param("rec_point_key",rec_point_key)

allocate( xylp(nkeys,ntraces), polys(2,nnodes), output(4,nnodes) )
 call sep_read(xylp,'xylp')


live_tri=0
dead_tri=0
do it=1,ntri
	found=0
	! Read info for a single triangle
	call sep_read(polys)
	do in=1,nnodes
		! Get node coordinates
		x1 = polys(1,in)
		y1 = polys(2,in)
		! Check all traces for matching coordinates
		do trace=1, ntraces
			x2 = xylp(rec_x_key,trace)
			y2 = xylp(rec_y_key,trace)
			! If coordinates match ...

			if (abs(x2-x1) <= sigma) then
				if (abs(y2-y1) <= sigma) then

					! Then grab the identifying info (rec line/point)
					rec_line  = xylp(rec_line_key,trace)
					rec_point = xylp(rec_point_key,trace)
					found = found + 1
					exit
				end if
			end if
		end do
		! Then assign the identifying info to the output
		output(1,in) = x1
		output(2,in) = y1
		output(3,in) = rec_line
		output(4,in) = rec_point
	end do

	! Write the output 
	call sep_write(output)
	live_tri = live_tri + 1

end do

write(0,*) "live tri", live_tri
write(0,*) "dead tri", dead_tri


 call to_history("n1",4)
 call to_history("label1",'(x, y, rec_line, rec_point)')
 call sep_close()
deallocate(output,xylp,polys)
end program
