program MORAN

use sep
implicit none

  integer					:: npar, nnodes, ntri, nsrc, nadded, it, is, fold
  real						:: vel, min_vel, off, min_offk, max_offk
  double precision				:: avg, sum
  real, dimension(:,:,:), allocatable 		:: output, output2
  real, dimension(:,:,:,:), allocatable 	:: input

 call sep_init()

 call from_history("n1", npar,   6)
 call from_history("n2", nnodes, 3)
 call from_history("n3", ntri,   1)
 call from_history("n4", nsrc,   1)

 call from_param("min_vel", min_vel)
 call from_param("min_off_killed", min_offk)
 call from_param("max_off_killed", max_offk)

 allocate( input(npar,nnodes,ntri,nsrc), output(4,nnodes,ntri), output2(4,nnodes,ntri) )
 input  = 0.0
 output = 0.0
 output2 = 0.0
 call sep_read(input)


! CALC THE WEIGHTING MATRIX
 do it=1, ntri
	do it=1, ntri
	


	end do
 end do


! CALC THE STATISTIC
 do it=1, ntri

	avg = 0.0
	sum = 0.0
	nadded = 0

	! Assign the output
	output(1:2,:,it) = input(1:2,:,it,1) ! Assign (x , y)
	output(3,:,it)   = -1
	output(4,:,it)   = 1.0

 	do is=1, nsrc
		off = input(5,1,it,is)
		! Skip triangle if offset is not in range
		if ( ( off > min_offk ) .and. ( off < max_offk ) ) cycle

		! Skip triangle if it is marked for kill
		if ( input(6,1,it,is) > 0 ) cycle

		! Skip triangle if it has very low velocity
		vel = input(3,1,it,is)
		if ( vel < min_vel ) cycle

!============  STATISTICS PART GOES HERE  ================================



!=========================================================================

	end do

	if (nadded > 0) then
		avg = (sum / dble(nadded))
		output(3,:,it)   = real(avg)
		output(4,:,it)   = 0.0

		!output2(3,:,it)  = real(nadded)
		!output2(4,:,it)  = 0.0
	end if
 end do

! Write the outputs
 call sep_write(output)

	! Assign the output2
	output2(:,:,:) = output

 if (exist_file('fold' )) call sep_write(output2 , 'fold' )

! For the statistic map 
 call to_history("n1",     4 )
 call to_history("n2",nnodes )
 call to_history("n3",ntri   )
 call to_history("n4",     1 )

 call to_history("label1", "(x, y, velocity [km/s], kill_val)" )
 call to_history("label2", "Node" )
 call to_history("label3", "Triangle" )
 call to_history("label4", " " )

! For the fold map 
 call to_history("n1",     4, 'fold' )
 call to_history("n2",nnodes, 'fold' )
 call to_history("n3",ntri  , 'fold' )
 call to_history("n4",     1, 'fold' )

 call to_history("label1", "(x, y, fold, kill_val)", 'fold' )
 call to_history("label2", "Node", 'fold' )
 call to_history("label3", "Triangle", 'fold' )
 call to_history("label4", " ", 'fold' )
 call sep_close()

end program
