program movieprep

  use sep
  implicit none

  integer          :: x_ind, y_ind
  integer          :: nn1,nn2,f1,f2,ff1,ff2,j1,j2,n1hdr,n2hdr,n1,n2
  real             :: min1,min2,max1,max2,d1,d2,o1,o2
  real,allocatable :: traces(:,:),xy(:,:),xyc(:,:,:)
  integer          :: jj,j,i,ii
  real             :: xy_scale

  call sep_init()

  call from_history('n1',n1,1 )
  call from_history('n2',n2,1 )
  call from_history('d1',d1,1.)
  call from_history('d2',d2,1.)
  call from_history('o1',o1,0.)
  call from_history('o2',o2,0.)

  call from_param('min1',min1,0.)
  call from_param('min2',min2,0.)
  call from_param('f1',f1,int((min1-o1)/d1))
  call from_param('f2',f2,int((min2-o2)/d2))
  call from_param('max1',max1,o1+(n1-1)*d1)
  call from_param('max2',max2,o2+(n2-1)*d2)
  call from_param('n1',nn1,1+int((max1-o1)/d1-f1))
  call from_param('n2',nn2,1+int((max2-o2)/d2-f1))
  
  call from_param('j1',j1,1)
  call from_param('j2',j2,1)
  
  call from_param('x_ind',x_ind,1)
  call from_param('y_ind',y_ind,2)
  call from_param('xy_scale',xy_scale,1.)
  
  call from_aux('hdr','n1',n1hdr)
  call from_aux('hdr','n2',n2hdr)
  
  if (n1hdr.lt.2) then
    write(0,*) '(n1hdr.lt.2)'; call exit(0)
  end if
  if (n2hdr.ne.n2) then
    write(0,*) '(n2hdr.ne.n2)'; call exit(0)
  end if

  call to_history('n1',nn2)
  call to_history('n2',  3)
  call to_history('n3',nn1)
  call to_history('d1', 1.)
  call to_history('d2', 1.)
  call to_history('d3', d1*j1)
  call to_history('o1', 0.)
  call to_history('o2', 0.)
  call to_history('o3', min1)
  
  call sep_close()

  allocate( traces(n1,n2), xy(n1hdr,n2hdr), xyc(nn2,3,nn1))

  call sreed('in',traces,4*n1*n2)
  call sreed('hdr',xy,4*n1hdr*n2hdr)
   
  ! Subsample
  j=0 
  do jj=1,nn2
    j=(jj-1)*j2+1
    traces(:,jj) = traces(:,j)
    xy(:,jj) = xy(:,j)
  end do
  do ii=1,nn1
    i=(ii-1)*j1+1
    traces(ii,:) = traces(i,:)
  end do
  
  ! Write a xyc file, for each time step
  do ii=1,nn1
  do jj=1,nn2
 !   write(0,*) (/ xy_scale*xy(x_ind,jj), xy_scale*xy(y_ind,jj), traces(ii,jj) /)
    xyc(jj,:,ii) = (/ xy_scale*xy(x_ind,jj), xy_scale*xy(y_ind,jj), traces(ii,jj) /) 
  end do
  end do
  call srite('out',xyc,4*size(xyc))

  deallocate(traces,xy,xyc)
  call exit(0)
  
end program
