program TEST

use sep
use eikonal_mod
implicit none

real, dimension(:,:), allocatable	:: output, tmp

 call sep_init()

allocate( output(3,3), tmp(3,3) )

output = 0.0
tmp=0.0

tmp(1,:) = (/ 0.0, 5.0, 0.0 /) ! x
tmp(2,:) = (/ 0.0, 0.0, 1000.0 /) ! y
tmp(3,:) = (/ -3.0, 0.0, 0.0 /) ! time


if (exist_file('tmp')) then
	call to_history("n1",3, 'tmp')
	call to_history("n2",3, 'tmp')
	call to_history("d1",1.0, 'tmp')
	call to_history("d2",1.0, 'tmp')
	call to_history("o1",0.0, 'tmp')
	call to_history("o2",0.0, 'tmp')
	call to_history("label1",'(x, y, velocity [km/s])', 'tmp')
	call to_history("label2",'Node', 'tmp')
	call sep_write(tmp, 'tmp')
end if


  ! Then compute the eikonal plane solution
  call eikonal_solver(tmp,output)

  call sep_write(output)

 call to_history("n1",3)
 call to_history("n2",3)
 call to_history("n3",1)
 call to_history("o1",1)
 call to_history("d1",1)
 call to_history("label1",'(x, y, velocity [km/s])' )
 call to_history("label2",'Node' )
 call to_history("label3",'Triangle' )

 call sep_close()
end program


